//Qt
#include <QCoreApplication>
#include <QFile>
#include <QStringList>
#include <QString>
#include <QProcess>
#include <QFileInfo>
#include <QDir>
#include <QSystemSemaphore>
#include <QSet>
#include <QDirIterator>

int main(int argc, char *argv[])
{
    QCoreApplication a(argc, argv);
    QStringList args = a.arguments();
    QSet<QString> set;
    QString appPath = QDir::currentPath();
    QSystemSemaphore sem("ocmupdater", 1, QSystemSemaphore::Open);
    sem.acquire();

    int count = argc-1;

    for(int i = 4; i < count; i += 2)
    {
        QString src = args.value(i);
        QString dest = args.value(i+1);

        if(src == dest || QFileInfo(src).baseName() == qApp->applicationName())
            continue;

        QString path = QFileInfo(dest).path();
        QString srcPath = QFileInfo(src).path();
        srcPath.remove(appPath);
        set.insert(srcPath);

        QDir dir(path);

        if(!dir.exists())
            dir.mkpath(path);

        if(!src.isEmpty() && !dest.isEmpty())
        {
            QFile::remove(dest);
            QFile::copy(src, dest);
            QFile::remove(src);
        }
    }

    QDirIterator it(QDir::current(), QDirIterator::Subdirectories);

    while(it.hasNext())
    {
        it.next();
        QFileInfo info(it.fileInfo());

        if(info.isDir())
        {
            QDir d = info.dir();

            if(d != QDir::current())
                d.removeRecursively();
        }
    }

    QString appName = args.value(1);

    if(!appName.isEmpty())
    {
        QString dirName = args.value(2);
        appName = (dirName.isEmpty() ? dirName : (dirName.endsWith('/') ? dirName : dirName + QStringLiteral("/"))) + appName;
        QStringList args = args.value(3).split(',');

        QProcess::startDetached(appName, args, dirName);
    }

    sem.release();
    exit(0);
    return a.exec();
}
